Subject: Re: [PATCH v2 1/2] mm/migrate_device.c: Copy pte dirty bit to page

From: Alistair Popple <[email-masked]>
Date: Fri, 26 Aug 2022 08:09:28 +1000

Peter Xu <[email-masked]> writes:

> On Thu, Aug 25, 2022 at 11:24:03AM +1000, Alistair Popple wrote:
>> By the way it's still an optimisation because in most cases we can avoid
>> calling try_to_migrate() and walking the rmap altogether if we install
>> the migration entries here. But I agree the comment is misleading.
>
> There's one follow up question I forgot to ask on the trylock thing.  I
> figured maybe I should ask out loud since we're at it.
>
> Since migrate_vma_setup() always only use trylock (even if before dropping
> the prepare() code), does it mean that it can randomly fail?

Yes, migration is always best effort and can randomly fail. For example
it can also fail because there are unexpected page references or pins.

> I looked at some of the callers, it seems not all of them are ready to
> handle that (__kvmppc_svm_page_out() or svm_migrate_vma_to_vram()).  Is it
> safe?  Do the callers need to always properly handle that (unless the
> migration is only a best-effort, but it seems not always the case).

Migration is always best effort. Callers need to be prepared to handle
failure of a particular page to migrate, but I could believe not all of
them are.

> Besides, since I read the old code of prepare(), I saw this comment:
>
> -		if (!(migrate->src[i] & MIGRATE_PFN_LOCKED)) {
> -			/*
> -			 * Because we are migrating several pages there can be
> -			 * a deadlock between 2 concurrent migration where each
> -			 * are waiting on each other page lock.
> -			 *
> -			 * Make migrate_vma() a best effort thing and backoff
> -			 * for any page we can not lock right away.
> -			 */
> -			if (!trylock_page(page)) {
> -				migrate->src[i] = 0;
> -				migrate->cpages--;
> -				put_page(page);
> -				continue;
> -			}
> -			remap = false;
> -			migrate->src[i] |= MIGRATE_PFN_LOCKED;
> -		}
>
> I'm a bit curious whether that deadlock mentioned in the comment is
> observed in reality?
>
> If the page was scanned in the same address space, logically the lock order
> should be guaranteed (if both page A&B, both threads should lock in order).
> I think the order can be changed if explicitly did so (e.g. fork() plus
> mremap() for anonymous here) but I just want to make sure I get the whole
> point of it.

You seem to have the point of it. The trylock_page() is to avoid
deadlock, and failure is always an option for migration. Drivers can
always retry if they really need the page to migrate, although success
is never guaranteed. For example the page might be pinned (or have
swap-cache allocated to it, but I'm hoping to at least get that fixed).

> Thanks,